<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.9.1"/>
<title>Тестовое задание: Исходный файл data_server.h</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td style="padding-left: 0.5em;">
   <div id="projectname">Тестовое задание
   </div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Создано системой Doxygen 1.8.9.1 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Титульная&#160;страница</span></a></li>
      <li><a href="annotated.html"><span>Классы</span></a></li>
      <li class="current"><a href="files.html"><span>Файлы</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.html"><span>Файлы</span></a></li>
    </ul>
  </div>
</div><!-- top -->
<div class="header">
  <div class="headertitle">
<div class="title">data_server.h</div>  </div>
</div><!--header-->
<div class="contents">
<a href="data__server_8h.html">См. документацию.</a><div class="fragment"><div class="line"><a name="l00001"></a><span class="lineno">    1</span>&#160;<span class="comment">/*</span></div>
<div class="line"><a name="l00002"></a><span class="lineno">    2</span>&#160;<span class="comment"> * data_server.h</span></div>
<div class="line"><a name="l00003"></a><span class="lineno">    3</span>&#160;<span class="comment"> *</span></div>
<div class="line"><a name="l00004"></a><span class="lineno">    4</span>&#160;<span class="comment"> *  Created on: Sep 13, 2016</span></div>
<div class="line"><a name="l00005"></a><span class="lineno">    5</span>&#160;<span class="comment"> *      Author: petrov</span></div>
<div class="line"><a name="l00006"></a><span class="lineno">    6</span>&#160;<span class="comment"> */</span></div>
<div class="line"><a name="l00007"></a><span class="lineno">    7</span>&#160;</div>
<div class="line"><a name="l00015"></a><span class="lineno">   15</span>&#160;<span class="preprocessor">#ifndef DATA_SERVER_H_</span></div>
<div class="line"><a name="l00016"></a><span class="lineno">   16</span>&#160;<span class="preprocessor">#define DATA_SERVER_H_</span></div>
<div class="line"><a name="l00017"></a><span class="lineno">   17</span>&#160;</div>
<div class="line"><a name="l00018"></a><span class="lineno">   18</span>&#160;<span class="preprocessor">#include &lt;stdint.h&gt;</span></div>
<div class="line"><a name="l00019"></a><span class="lineno">   19</span>&#160;</div>
<div class="line"><a name="l00020"></a><span class="lineno">   20</span>&#160;<span class="comment">// containers</span></div>
<div class="line"><a name="l00021"></a><span class="lineno">   21</span>&#160;<span class="preprocessor">#include &lt;map&gt;</span></div>
<div class="line"><a name="l00022"></a><span class="lineno">   22</span>&#160;<span class="preprocessor">#include &lt;set&gt;</span></div>
<div class="line"><a name="l00023"></a><span class="lineno">   23</span>&#160;</div>
<div class="line"><a name="l00024"></a><span class="lineno">   24</span>&#160;<span class="comment">// files</span></div>
<div class="line"><a name="l00025"></a><span class="lineno">   25</span>&#160;<span class="preprocessor">#include &lt;fstream&gt;</span></div>
<div class="line"><a name="l00026"></a><span class="lineno">   26</span>&#160;</div>
<div class="line"><a name="l00027"></a><span class="lineno">   27</span>&#160;<span class="keyword">using namespace </span><a class="code" href="namespacestd.html">std</a>;</div>
<div class="line"><a name="l00028"></a><span class="lineno">   28</span>&#160;</div>
<div class="line"><a name="l00029"></a><span class="lineno">   29</span>&#160;<span class="preprocessor">#define STORAGE_FILENAME    &quot;data_&quot;</span></div>
<div class="line"><a name="l00030"></a><span class="lineno">   30</span>&#160;<span class="preprocessor">#define STORAGE_DIRECTORY   &quot;.&quot;</span></div>
<div class="line"><a name="l00031"></a><span class="lineno">   31</span>&#160;</div>
<div class="line"><a name="l00032"></a><span class="lineno">   32</span>&#160;</div>
<div class="line"><a name="l00038"></a><span class="lineno"><a class="line" href="class_data_blob.html">   38</a></span>&#160;<span class="keyword">class </span><a class="code" href="class_data_blob.html">DataBlob</a> {</div>
<div class="line"><a name="l00039"></a><span class="lineno">   39</span>&#160;</div>
<div class="line"><a name="l00040"></a><span class="lineno">   40</span>&#160;<span class="keyword">public</span>:</div>
<div class="line"><a name="l00041"></a><span class="lineno">   41</span>&#160;</div>
<div class="line"><a name="l00054"></a><span class="lineno">   54</span>&#160;    <a class="code" href="class_data_blob.html">DataBlob</a>(uint64_t blockSize, uint32_t blobSize);</div>
<div class="line"><a name="l00055"></a><span class="lineno">   55</span>&#160;</div>
<div class="line"><a name="l00059"></a><span class="lineno">   59</span>&#160;    ~<a class="code" href="class_data_blob.html">DataBlob</a>();</div>
<div class="line"><a name="l00060"></a><span class="lineno">   60</span>&#160;</div>
<div class="line"><a name="l00069"></a><span class="lineno">   69</span>&#160;    <span class="keywordtype">int</span> getBlock(uint64_t blockPos, <span class="keywordtype">char</span>* blockData);</div>
<div class="line"><a name="l00070"></a><span class="lineno">   70</span>&#160;</div>
<div class="line"><a name="l00078"></a><span class="lineno">   78</span>&#160;    <span class="keywordtype">int</span> putBlock(<span class="keyword">const</span> <span class="keywordtype">char</span>* blockData);</div>
<div class="line"><a name="l00079"></a><span class="lineno">   79</span>&#160;</div>
<div class="line"><a name="l00085"></a><span class="lineno">   85</span>&#160;    <span class="keywordtype">int</span> getPosition();</div>
<div class="line"><a name="l00086"></a><span class="lineno">   86</span>&#160;</div>
<div class="line"><a name="l00092"></a><span class="lineno">   92</span>&#160;    <span class="keywordtype">string</span> getFilename();</div>
<div class="line"><a name="l00093"></a><span class="lineno">   93</span>&#160;</div>
<div class="line"><a name="l00101"></a><span class="lineno">  101</span>&#160;    <span class="keywordtype">int</span> open(<span class="keywordtype">string</span> fileName);</div>
<div class="line"><a name="l00102"></a><span class="lineno">  102</span>&#160;</div>
<div class="line"><a name="l00104"></a><span class="lineno"><a class="line" href="class_data_blob.html#a9542f97660974ad6c323fa95db995a35">  104</a></span>&#160;    <span class="keyword">enum</span> <a class="code" href="class_data_blob.html#a9542f97660974ad6c323fa95db995a35">errs</a> {</div>
<div class="line"><a name="l00105"></a><span class="lineno"><a class="line" href="class_data_blob.html#a9542f97660974ad6c323fa95db995a35ae8d722cb862d40233524fc6cc3108daf">  105</a></span>&#160;        <a class="code" href="class_data_blob.html#a9542f97660974ad6c323fa95db995a35ae8d722cb862d40233524fc6cc3108daf">SUCCESS</a>, </div>
<div class="line"><a name="l00106"></a><span class="lineno"><a class="line" href="class_data_blob.html#a9542f97660974ad6c323fa95db995a35a7246f700ffa6b22526808cd5c2ea7399">  106</a></span>&#160;        ERR_BLOB_NOT_OPENED = -1, </div>
<div class="line"><a name="l00107"></a><span class="lineno"><a class="line" href="class_data_blob.html#a9542f97660974ad6c323fa95db995a35ad2e9575e6d11ffea6f7feef53060a16b">  107</a></span>&#160;        ERR_BLOB_IS_RO      = -2, </div>
<div class="line"><a name="l00108"></a><span class="lineno"><a class="line" href="class_data_blob.html#a9542f97660974ad6c323fa95db995a35ad6e98cd11371fc20c9848869d1dded4a">  108</a></span>&#160;        ERR_BLOB_IS_FULL    = -3 </div>
<div class="line"><a name="l00109"></a><span class="lineno">  109</span>&#160;    };</div>
<div class="line"><a name="l00110"></a><span class="lineno">  110</span>&#160;</div>
<div class="line"><a name="l00111"></a><span class="lineno">  111</span>&#160;<span class="keyword">private</span>:</div>
<div class="line"><a name="l00112"></a><span class="lineno">  112</span>&#160;</div>
<div class="line"><a name="l00114"></a><span class="lineno">  114</span>&#160;    <span class="keyword">enum</span> states {</div>
<div class="line"><a name="l00115"></a><span class="lineno">  115</span>&#160;        STATE_NOT_OPENED, </div>
<div class="line"><a name="l00116"></a><span class="lineno">  116</span>&#160;        STATE_RO, </div>
<div class="line"><a name="l00117"></a><span class="lineno">  117</span>&#160;        STATE_RW </div>
<div class="line"><a name="l00118"></a><span class="lineno">  118</span>&#160;    };</div>
<div class="line"><a name="l00119"></a><span class="lineno">  119</span>&#160;</div>
<div class="line"><a name="l00120"></a><span class="lineno">  120</span>&#160;    fstream _fileBlob; </div>
<div class="line"><a name="l00121"></a><span class="lineno">  121</span>&#160;    uint64_t _blockSize; </div>
<div class="line"><a name="l00122"></a><span class="lineno">  122</span>&#160;    uint32_t _blobSize; </div>
<div class="line"><a name="l00123"></a><span class="lineno">  123</span>&#160;    <span class="keywordtype">string</span> _fileName; </div>
<div class="line"><a name="l00124"></a><span class="lineno">  124</span>&#160;    <span class="keywordtype">unsigned</span> <span class="keywordtype">char</span> _state; </div>
<div class="line"><a name="l00125"></a><span class="lineno">  125</span>&#160;};</div>
<div class="line"><a name="l00126"></a><span class="lineno">  126</span>&#160;</div>
<div class="line"><a name="l00141"></a><span class="lineno"><a class="line" href="class_data_server.html">  141</a></span>&#160;<span class="keyword">class </span><a class="code" href="class_data_server.html">DataServer</a> {</div>
<div class="line"><a name="l00142"></a><span class="lineno">  142</span>&#160;</div>
<div class="line"><a name="l00143"></a><span class="lineno">  143</span>&#160;<span class="keyword">public</span>:</div>
<div class="line"><a name="l00144"></a><span class="lineno">  144</span>&#160;</div>
<div class="line"><a name="l00148"></a><span class="lineno">  148</span>&#160;    <a class="code" href="class_data_server.html">DataServer</a>();</div>
<div class="line"><a name="l00149"></a><span class="lineno">  149</span>&#160;</div>
<div class="line"><a name="l00153"></a><span class="lineno">  153</span>&#160;    ~<a class="code" href="class_data_server.html">DataServer</a>();</div>
<div class="line"><a name="l00154"></a><span class="lineno">  154</span>&#160;</div>
<div class="line"><a name="l00163"></a><span class="lineno">  163</span>&#160;    <span class="keywordtype">int</span> init(uint64_t blockSize, uint32_t blobSize);</div>
<div class="line"><a name="l00164"></a><span class="lineno">  164</span>&#160;</div>
<div class="line"><a name="l00173"></a><span class="lineno">  173</span>&#160;    <span class="keywordtype">int</span> putBlock(uint64_t blockId, <span class="keyword">const</span> <span class="keywordtype">char</span>* blockData);</div>
<div class="line"><a name="l00174"></a><span class="lineno">  174</span>&#160;</div>
<div class="line"><a name="l00183"></a><span class="lineno">  183</span>&#160;    <span class="keywordtype">int</span> getBlock(uint64_t blockId, <span class="keywordtype">char</span>* blockData);</div>
<div class="line"><a name="l00184"></a><span class="lineno">  184</span>&#160;</div>
<div class="line"><a name="l00186"></a><span class="lineno"><a class="line" href="class_data_server.html#a224fa4f36c85fcbce3df48f4c2aaeb8d">  186</a></span>&#160;    <span class="keyword">enum</span> <a class="code" href="class_data_server.html#a224fa4f36c85fcbce3df48f4c2aaeb8d">errs</a> {</div>
<div class="line"><a name="l00187"></a><span class="lineno"><a class="line" href="class_data_server.html#a224fa4f36c85fcbce3df48f4c2aaeb8da593852054b513cea873bd1e73c593498">  187</a></span>&#160;        <a class="code" href="class_data_server.html#a224fa4f36c85fcbce3df48f4c2aaeb8da593852054b513cea873bd1e73c593498">SUCCESS</a>, </div>
<div class="line"><a name="l00188"></a><span class="lineno"><a class="line" href="class_data_server.html#a224fa4f36c85fcbce3df48f4c2aaeb8da929982c48a3240f33eb4fdefcb14abe2">  188</a></span>&#160;        ERR_ALREADY_INITIALIZED = -1, </div>
<div class="line"><a name="l00189"></a><span class="lineno"><a class="line" href="class_data_server.html#a224fa4f36c85fcbce3df48f4c2aaeb8da2be97d8b1e7116bd395eb51fb89c8a36">  189</a></span>&#160;        ERR_BLOCK_ID_EXIST      = -2, </div>
<div class="line"><a name="l00190"></a><span class="lineno"><a class="line" href="class_data_server.html#a224fa4f36c85fcbce3df48f4c2aaeb8da13289cf9a5cdda04a784ee47529e807f">  190</a></span>&#160;        ERR_BLOCK_DATA_EXIST    = -3, </div>
<div class="line"><a name="l00191"></a><span class="lineno"><a class="line" href="class_data_server.html#a224fa4f36c85fcbce3df48f4c2aaeb8daa136f54a5c96b4c0be75afd1532cd983">  191</a></span>&#160;        ERR_BLOCK_ID_NOT_EXIST  = -4 </div>
<div class="line"><a name="l00192"></a><span class="lineno">  192</span>&#160;    };</div>
<div class="line"><a name="l00193"></a><span class="lineno">  193</span>&#160;</div>
<div class="line"><a name="l00194"></a><span class="lineno">  194</span>&#160;<span class="keyword">private</span>:</div>
<div class="line"><a name="l00195"></a><span class="lineno">  195</span>&#160;</div>
<div class="line"><a name="l00197"></a><span class="lineno">  197</span>&#160;    <span class="keyword">struct </span>blockDesc {</div>
<div class="line"><a name="l00198"></a><span class="lineno">  198</span>&#160;        <span class="keywordtype">size_t</span> hash; </div>
<div class="line"><a name="l00199"></a><span class="lineno">  199</span>&#160;        <span class="keywordtype">string</span> fileName; </div>
<div class="line"><a name="l00200"></a><span class="lineno">  200</span>&#160;        uint64_t position; </div>
<div class="line"><a name="l00201"></a><span class="lineno">  201</span>&#160;    };</div>
<div class="line"><a name="l00202"></a><span class="lineno">  202</span>&#160;</div>
<div class="line"><a name="l00203"></a><span class="lineno">  203</span>&#160;    map&lt;uint64_t, blockDesc&gt; _tableIndex; </div>
<div class="line"><a name="l00204"></a><span class="lineno">  204</span>&#160;    map&lt;size_t, uint64_t&gt; _tableHash; </div>
<div class="line"><a name="l00206"></a><span class="lineno">  206</span>&#160;    uint64_t _blockSize; </div>
<div class="line"><a name="l00207"></a><span class="lineno">  207</span>&#160;    uint32_t _blobSize; </div>
<div class="line"><a name="l00209"></a><span class="lineno">  209</span>&#160;    <a class="code" href="class_data_blob.html">DataBlob</a> *_wBlob; </div>
<div class="line"><a name="l00210"></a><span class="lineno">  210</span>&#160;    <a class="code" href="class_data_blob.html">DataBlob</a> *_rBlob; </div>
<div class="line"><a name="l00212"></a><span class="lineno">  212</span>&#160;    <span class="keywordtype">string</span> _rBlobFileName; </div>
<div class="line"><a name="l00213"></a><span class="lineno">  213</span>&#160;    uint32_t _wBlobCount; </div>
<div class="line"><a name="l00214"></a><span class="lineno">  214</span>&#160;};</div>
<div class="line"><a name="l00215"></a><span class="lineno">  215</span>&#160;</div>
<div class="line"><a name="l00216"></a><span class="lineno">  216</span>&#160;<span class="preprocessor">#endif </span><span class="comment">/* DATA_SERVER_H_ */</span><span class="preprocessor"></span></div>
<div class="ttc" id="namespacestd_html"><div class="ttname"><a href="namespacestd.html">std</a></div></div>
<div class="ttc" id="class_data_server_html"><div class="ttname"><a href="class_data_server.html">DataServer</a></div><div class="ttdoc">Класс описания работы сервера для хранения данных </div><div class="ttdef"><b>Definition:</b> data_server.h:141</div></div>
<div class="ttc" id="class_data_blob_html_a9542f97660974ad6c323fa95db995a35"><div class="ttname"><a href="class_data_blob.html#a9542f97660974ad6c323fa95db995a35">DataBlob::errs</a></div><div class="ttdeci">errs</div><div class="ttdoc">Набор ошибок - результатов выполнения операций </div><div class="ttdef"><b>Definition:</b> data_server.h:104</div></div>
<div class="ttc" id="class_data_server_html_a224fa4f36c85fcbce3df48f4c2aaeb8da593852054b513cea873bd1e73c593498"><div class="ttname"><a href="class_data_server.html#a224fa4f36c85fcbce3df48f4c2aaeb8da593852054b513cea873bd1e73c593498">DataServer::SUCCESS</a></div><div class="ttdoc">успешное выполнение </div><div class="ttdef"><b>Definition:</b> data_server.h:187</div></div>
<div class="ttc" id="class_data_server_html_a224fa4f36c85fcbce3df48f4c2aaeb8d"><div class="ttname"><a href="class_data_server.html#a224fa4f36c85fcbce3df48f4c2aaeb8d">DataServer::errs</a></div><div class="ttdeci">errs</div><div class="ttdoc">Набор ошибок - результатов выполнения операций </div><div class="ttdef"><b>Definition:</b> data_server.h:186</div></div>
<div class="ttc" id="class_data_blob_html"><div class="ttname"><a href="class_data_blob.html">DataBlob</a></div><div class="ttdoc">Класс описания Блоба для хранения данных </div><div class="ttdef"><b>Definition:</b> data_server.h:38</div></div>
<div class="ttc" id="class_data_blob_html_a9542f97660974ad6c323fa95db995a35ae8d722cb862d40233524fc6cc3108daf"><div class="ttname"><a href="class_data_blob.html#a9542f97660974ad6c323fa95db995a35ae8d722cb862d40233524fc6cc3108daf">DataBlob::SUCCESS</a></div><div class="ttdoc">успешное выполнение </div><div class="ttdef"><b>Definition:</b> data_server.h:105</div></div>
</div><!-- fragment --></div><!-- contents -->
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Документация по Тестовое задание. Последние изменения: Вт 13 Сен 2016 20:23:58. Создано системой &#160;<a href="http://www.doxygen.org/index.html">
<img class="footer" src="doxygen.png" alt="doxygen"/>
</a> 1.8.9.1
</small></address>
</body>
</html>
